import math


def solution(n: int, p: int, g6_: list, a: list, b: list) -> int:
    # for zi, ai, bi in g6:
    if n == 1:
        zi, ai, bi = g6_[0]
        if ai * zi >= p:
            return math.ceil(p / ai)
        return math.ceil((p - ai * zi + bi * zi) / bi)
    elif n == 2:
        g6 = sorted(g6_, key=lambda x: x[0])
        if g6[0][0] * g6[0][1] + g6[0][1] * g6[1][1] == p:
            return g6[0][0]
        elif g6[0][0] * g6[0][1] + g6[0][1] * g6[1][1] > p:
            return math.ceil(p / (g6[0][1] + g6[1][1]))
        else:
            a = g6[1][0] * g6[1][1]
            b = g6[0][0] * g6[0][1]
            c = g6[0][2] * (g6[1][0] - g6[0][0])
            ans = a + b + c
            if ans == p:
                return g6[1][0]
            elif ans < p:
                a = g6_[0][1] * g6_[0][0]
                b = g6_[0][0] * g6_[0][2]
                c = g6_[1][1] * g6_[1][0]
                d = g6_[1][2] * g6_[1][0]
                return math.ceil((p - a + b - c + d) / (g6_[0][2] + g6_[1][2]))
            else:
                right = g6[1][0]
                left = g6[0][0]
                while left <= right:
                    mid = (right - left) // 2
                    a = (g6[0][0] + mid) * g6[1][1]
                    b = g6[0][0] * g6[0][1]
                    c = g6[0][2] * (g6[0][0] + mid)
                    ans = a + b + c
                    if ans > p:
                        right = mid - 1
                    elif ans == p:
                        return mid + g6[0][0]
                    else:
                        left = mid + 1
                return mid + g6[0][0]
    else:
        z = g6_[0][0]
        a_sum = sum(a)
        b_sum = sum(b)
        if z * a_sum == p:
            return z
        elif z * a_sum > p:
            return math.ceil(p / a_sum)
        return math.ceil((p - a_sum * z + b_sum * z) / b_sum)


def main():
    n, p = map(int, input().split())
    a = []
    b = []
    g6 = []
    for i in range(n):
        zi, ai, bi = map(int, input().split())
        a.append(ai)
        b.append(bi)
        g6.append([zi, ai, bi])
    print(solution(n, p, g6, a, b))

main()